t / test-lib.shon commit Merge branch 'sb/mailmap-updates' (4fcd30d)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29fi
  30if test -z "$TEST_OUTPUT_DIRECTORY"
  31then
  32        # Similarly, override this to store the test-results subdir
  33        # elsewhere
  34        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  35fi
  36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  37
  38################################################################
  39# It appears that people try to run tests without building...
  40"$GIT_BUILD_DIR/git" >/dev/null
  41if test $? != 1
  42then
  43        echo >&2 'error: you do not seem to have built git yet.'
  44        exit 1
  45fi
  46
  47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  48export PERL_PATH SHELL_PATH
  49
  50# if --tee was passed, write the output not only to the terminal, but
  51# additionally to the file test-results/$BASENAME.out, too.
  52case "$GIT_TEST_TEE_STARTED, $* " in
  53done,*)
  54        # do not redirect again
  55        ;;
  56*' --tee '*|*' --va'*)
  57        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  58        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  59        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  60         echo $? > $BASE.exit) | tee $BASE.out
  61        test "$(cat $BASE.exit)" = 0
  62        exit
  63        ;;
  64esac
  65
  66# For repeatability, reset the environment to known value.
  67LANG=C
  68LC_ALL=C
  69PAGER=cat
  70TZ=UTC
  71TERM=dumb
  72export LANG LC_ALL PAGER TERM TZ
  73EDITOR=:
  74# A call to "unset" with no arguments causes at least Solaris 10
  75# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  76# deriving from the command substitution clustered with the other
  77# ones.
  78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  79        my @env = keys %ENV;
  80        my $ok = join("|", qw(
  81                TRACE
  82                DEBUG
  83                USE_LOOKUP
  84                TEST
  85                .*_TEST
  86                PROVE
  87                VALGRIND
  88                UNZIP
  89                PERF_
  90        ));
  91        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  92        print join("\n", @vars);
  93')
  94unset XDG_CONFIG_HOME
  95unset GITPERLLIB
  96GIT_AUTHOR_EMAIL=author@example.com
  97GIT_AUTHOR_NAME='A U Thor'
  98GIT_COMMITTER_EMAIL=committer@example.com
  99GIT_COMMITTER_NAME='C O Mitter'
 100GIT_MERGE_VERBOSITY=5
 101GIT_MERGE_AUTOEDIT=no
 102export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 103export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 104export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 105export EDITOR
 106
 107# Add libc MALLOC and MALLOC_PERTURB test
 108# only if we are not executing the test with valgrind
 109if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 110   test -n "$TEST_NO_MALLOC_CHECK"
 111then
 112        setup_malloc_check () {
 113                : nothing
 114        }
 115        teardown_malloc_check () {
 116                : nothing
 117        }
 118else
 119        setup_malloc_check () {
 120                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 121                export MALLOC_CHECK_ MALLOC_PERTURB_
 122        }
 123        teardown_malloc_check () {
 124                unset MALLOC_CHECK_ MALLOC_PERTURB_
 125        }
 126fi
 127
 128# Protect ourselves from common misconfiguration to export
 129# CDPATH into the environment
 130unset CDPATH
 131
 132unset GREP_OPTIONS
 133unset UNZIP
 134
 135case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1361|2|true)
 137        echo "* warning: Some tests will not work if GIT_TRACE" \
 138                "is set as to trace on STDERR ! *"
 139        echo "* warning: Please set GIT_TRACE to something" \
 140                "other than 1, 2 or true ! *"
 141        ;;
 142esac
 143
 144# Convenience
 145#
 146# A regexp to match 5 and 40 hexdigits
 147_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 148_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 149
 150# Zero SHA-1
 151_z40=0000000000000000000000000000000000000000
 152
 153# Line feed
 154LF='
 155'
 156
 157export _x05 _x40 _z40 LF
 158
 159# Each test should start with something like this, after copyright notices:
 160#
 161# test_description='Description of this test...
 162# This test checks if command xyzzy does the right thing...
 163# '
 164# . ./test-lib.sh
 165[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 166                TERM=$ORIGINAL_TERM &&
 167                export TERM &&
 168                [ -t 1 ] &&
 169                tput bold >/dev/null 2>&1 &&
 170                tput setaf 1 >/dev/null 2>&1 &&
 171                tput sgr0 >/dev/null 2>&1
 172        ) &&
 173        color=t
 174
 175while test "$#" -ne 0
 176do
 177        case "$1" in
 178        -d|--d|--de|--deb|--debu|--debug)
 179                debug=t; shift ;;
 180        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 181                immediate=t; shift ;;
 182        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 183                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 184        -h|--h|--he|--hel|--help)
 185                help=t; shift ;;
 186        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 187                verbose=t; shift ;;
 188        --verbose-only=*)
 189                verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 190                shift ;;
 191        -q|--q|--qu|--qui|--quie|--quiet)
 192                # Ignore --quiet under a TAP::Harness. Saying how many tests
 193                # passed without the ok/not ok details is always an error.
 194                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 195        --with-dashes)
 196                with_dashes=t; shift ;;
 197        --no-color)
 198                color=; shift ;;
 199        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 200                valgrind=memcheck
 201                shift ;;
 202        --valgrind=*)
 203                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 204                shift ;;
 205        --valgrind-only=*)
 206                valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 207                shift ;;
 208        --valgrind-parallel=*)
 209                valgrind_parallel=$(expr "z$1" : 'z[^=]*=\(.*\)')
 210                shift ;;
 211        --valgrind-only-stride=*)
 212                valgrind_only_stride=$(expr "z$1" : 'z[^=]*=\(.*\)')
 213                shift ;;
 214        --valgrind-only-offset=*)
 215                valgrind_only_offset=$(expr "z$1" : 'z[^=]*=\(.*\)')
 216                shift ;;
 217        --tee)
 218                shift ;; # was handled already
 219        --root=*)
 220                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 221                shift ;;
 222        --statusprefix=*)
 223                statusprefix=$(expr "z$1" : 'z[^=]*=\(.*\)')
 224                shift ;;
 225        *)
 226                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 227        esac
 228done
 229
 230if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
 231then
 232        test -z "$valgrind" && valgrind=memcheck
 233        test -z "$verbose" && verbose_only="$valgrind_only"
 234elif test -n "$valgrind"
 235then
 236        verbose=t
 237fi
 238
 239if test -n "$color"
 240then
 241        say_color () {
 242                (
 243                TERM=$ORIGINAL_TERM
 244                export TERM
 245                case "$1" in
 246                error)
 247                        tput bold; tput setaf 1;; # bold red
 248                skip)
 249                        tput setaf 4;; # blue
 250                warn)
 251                        tput setaf 3;; # brown/yellow
 252                pass)
 253                        tput setaf 2;; # green
 254                info)
 255                        tput setaf 6;; # cyan
 256                *)
 257                        test -n "$quiet" && return;;
 258                esac
 259                shift
 260                printf "%s" "$*"
 261                tput sgr0
 262                echo
 263                )
 264        }
 265else
 266        say_color() {
 267                test -z "$1" && test -n "$quiet" && return
 268                shift
 269                printf "%s\n" "$*"
 270        }
 271fi
 272
 273error () {
 274        say_color error "error: $*"
 275        GIT_EXIT_OK=t
 276        exit 1
 277}
 278
 279say () {
 280        say_color info "$*"
 281}
 282
 283test "${test_description}" != "" ||
 284error "Test script did not set test_description."
 285
 286if test "$help" = "t"
 287then
 288        echo "$test_description"
 289        exit 0
 290fi
 291
 292exec 5>&1
 293exec 6<&0
 294if test "$verbose" = "t"
 295then
 296        exec 4>&2 3>&1
 297else
 298        exec 4>/dev/null 3>/dev/null
 299fi
 300
 301test_failure=0
 302test_count=0
 303test_fixed=0
 304test_broken=0
 305test_success=0
 306
 307test_external_has_tap=0
 308
 309die () {
 310        code=$?
 311        if test -n "$GIT_EXIT_OK"
 312        then
 313                exit $code
 314        else
 315                echo >&5 "FATAL: Unexpected exit with code $code"
 316                exit 1
 317        fi
 318}
 319
 320GIT_EXIT_OK=
 321trap 'die' EXIT
 322
 323# The user-facing functions are loaded from a separate file so that
 324# test_perf subshells can have them too
 325. "$TEST_DIRECTORY/test-lib-functions.sh"
 326
 327# You are not expected to call test_ok_ and test_failure_ directly, use
 328# the text_expect_* functions instead.
 329
 330test_ok_ () {
 331        test_success=$(($test_success + 1))
 332        say_color "" "${statusprefix}ok $test_count - $@"
 333}
 334
 335test_failure_ () {
 336        test_failure=$(($test_failure + 1))
 337        say_color error "${statusprefix}not ok $test_count - $1"
 338        shift
 339        echo "$@" | sed -e 's/^/#       /'
 340        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 341}
 342
 343test_known_broken_ok_ () {
 344        test_fixed=$(($test_fixed+1))
 345        say_color error "${statusprefix}ok $test_count - $@ # TODO known breakage vanished"
 346}
 347
 348test_known_broken_failure_ () {
 349        test_broken=$(($test_broken+1))
 350        say_color warn "${statusprefix}not ok $test_count - $@ # TODO known breakage"
 351}
 352
 353test_debug () {
 354        test "$debug" = "" || eval "$1"
 355}
 356
 357match_pattern_list () {
 358        arg="$1"
 359        shift
 360        test -z "$*" && return 1
 361        for pattern_
 362        do
 363                case "$arg" in
 364                $pattern_)
 365                        return 0
 366                esac
 367        done
 368        return 1
 369}
 370
 371maybe_teardown_verbose () {
 372        test -z "$verbose_only" && return
 373        exec 4>/dev/null 3>/dev/null
 374        verbose=
 375}
 376
 377last_verbose=t
 378maybe_setup_verbose () {
 379        test -z "$verbose_only" && return
 380        if match_pattern_list $test_count $verbose_only ||
 381                { test -n "$valgrind_only_stride" &&
 382                expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null; }
 383        then
 384                exec 4>&2 3>&1
 385                # Emit a delimiting blank line when going from
 386                # non-verbose to verbose.  Within verbose mode the
 387                # delimiter is printed by test_expect_*.  The choice
 388                # of the initial $last_verbose is such that before
 389                # test 1, we do not print it.
 390                test -z "$last_verbose" && echo >&3 ""
 391                verbose=t
 392        else
 393                exec 4>/dev/null 3>/dev/null
 394                verbose=
 395        fi
 396        last_verbose=$verbose
 397}
 398
 399maybe_teardown_valgrind () {
 400        test -z "$GIT_VALGRIND" && return
 401        GIT_VALGRIND_ENABLED=
 402}
 403
 404maybe_setup_valgrind () {
 405        test -z "$GIT_VALGRIND" && return
 406        if test -z "$valgrind_only" && test -z "$valgrind_only_stride"
 407        then
 408                GIT_VALGRIND_ENABLED=t
 409                return
 410        fi
 411        GIT_VALGRIND_ENABLED=
 412        if match_pattern_list $test_count $valgrind_only
 413        then
 414                GIT_VALGRIND_ENABLED=t
 415        elif test -n "$valgrind_only_stride" &&
 416                expr $test_count "%" $valgrind_only_stride - $valgrind_only_offset = 0 >/dev/null
 417        then
 418                GIT_VALGRIND_ENABLED=t
 419        fi
 420}
 421
 422test_eval_ () {
 423        # This is a separate function because some tests use
 424        # "return" to end a test_expect_success block early.
 425        eval </dev/null >&3 2>&4 "$*"
 426}
 427
 428test_run_ () {
 429        test_cleanup=:
 430        expecting_failure=$2
 431        setup_malloc_check
 432        test_eval_ "$1"
 433        eval_ret=$?
 434        teardown_malloc_check
 435
 436        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 437        then
 438                setup_malloc_check
 439                test_eval_ "$test_cleanup"
 440                teardown_malloc_check
 441        fi
 442        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 443        then
 444                echo ""
 445        fi
 446        return "$eval_ret"
 447}
 448
 449test_start_ () {
 450        test_count=$(($test_count+1))
 451        maybe_setup_verbose
 452        maybe_setup_valgrind
 453}
 454
 455test_finish_ () {
 456        echo >&3 ""
 457        maybe_teardown_valgrind
 458        maybe_teardown_verbose
 459}
 460
 461test_skip () {
 462        to_skip=
 463        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 464        then
 465                to_skip=t
 466        fi
 467        if test -z "$to_skip" && test -n "$test_prereq" &&
 468           ! test_have_prereq "$test_prereq"
 469        then
 470                to_skip=t
 471        fi
 472        case "$to_skip" in
 473        t)
 474                of_prereq=
 475                if test "$missing_prereq" != "$test_prereq"
 476                then
 477                        of_prereq=" of $test_prereq"
 478                fi
 479
 480                say_color skip >&3 "${statusprefix}skipping test: $@"
 481                say_color skip "${statusprefix}ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 482                : true
 483                ;;
 484        *)
 485                false
 486                ;;
 487        esac
 488}
 489
 490# stub; perf-lib overrides it
 491test_at_end_hook_ () {
 492        :
 493}
 494
 495test_done () {
 496        GIT_EXIT_OK=t
 497
 498        # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
 499        # output file
 500        if test -z "$HARNESS_ACTIVE"
 501        then
 502                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 503                mkdir -p "$test_results_dir"
 504                base=${0##*/}
 505                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 506
 507                cat >>"$test_results_path" <<-EOF
 508                total $test_count
 509                success $test_success
 510                fixed $test_fixed
 511                broken $test_broken
 512                failed $test_failure
 513
 514                EOF
 515        fi
 516
 517        if test "$test_fixed" != 0
 518        then
 519                say_color error "${statusprefix}# $test_fixed known breakage(s) vanished; please update test(s)"
 520        fi
 521        if test "$test_broken" != 0
 522        then
 523                say_color warn "${statusprefix}# still have $test_broken known breakage(s)"
 524        fi
 525        if test "$test_broken" != 0 || test "$test_fixed" != 0
 526        then
 527                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 528                msg="remaining $test_remaining test(s)"
 529        else
 530                test_remaining=$test_count
 531                msg="$test_count test(s)"
 532        fi
 533        case "$test_failure" in
 534        0)
 535                # Maybe print SKIP message
 536                if test -n "$skip_all" && test $test_count -gt 0
 537                then
 538                        error "Can't use skip_all after running some tests"
 539                fi
 540                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 541
 542                if test $test_external_has_tap -eq 0
 543                then
 544                        if test $test_remaining -gt 0
 545                        then
 546                                say_color pass "${statusprefix}# passed all $msg"
 547                        fi
 548                        say "${statusprefix}1..$test_count$skip_all"
 549                fi
 550
 551                test -d "$remove_trash" &&
 552                cd "$(dirname "$remove_trash")" &&
 553                rm -rf "$(basename "$remove_trash")"
 554
 555                test_at_end_hook_
 556
 557                exit 0 ;;
 558
 559        *)
 560                if test $test_external_has_tap -eq 0
 561                then
 562                        say_color error "${statusprefix}# failed $test_failure among $msg"
 563                        say "${statusprefix}1..$test_count"
 564                fi
 565
 566                exit 1 ;;
 567
 568        esac
 569}
 570
 571
 572# Set up a directory that we can put in PATH which redirects all git
 573# calls to 'valgrind git ...'.
 574if test -n "$valgrind"
 575then
 576        make_symlink () {
 577                test -h "$2" &&
 578                test "$1" = "$(readlink "$2")" || {
 579                        # be super paranoid
 580                        if mkdir "$2".lock
 581                        then
 582                                rm -f "$2" &&
 583                                ln -s "$1" "$2" &&
 584                                rm -r "$2".lock
 585                        else
 586                                while test -d "$2".lock
 587                                do
 588                                        say "Waiting for lock on $2."
 589                                        sleep 1
 590                                done
 591                        fi
 592                }
 593        }
 594
 595        make_valgrind_symlink () {
 596                # handle only executables, unless they are shell libraries that
 597                # need to be in the exec-path.  We will just use "#!" as a
 598                # guess for a shell-script, since we have no idea what the user
 599                # may have configured as the shell path.
 600                test -x "$1" ||
 601                test "#!" = "$(head -c 2 <"$1")" ||
 602                return;
 603
 604                base=$(basename "$1")
 605                symlink_target=$GIT_BUILD_DIR/$base
 606                # do not override scripts
 607                if test -x "$symlink_target" &&
 608                    test ! -d "$symlink_target" &&
 609                    test "#!" != "$(head -c 2 < "$symlink_target")"
 610                then
 611                        symlink_target=../valgrind.sh
 612                fi
 613                case "$base" in
 614                *.sh|*.perl)
 615                        symlink_target=../unprocessed-script
 616                esac
 617                # create the link, or replace it if it is out of date
 618                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 619        }
 620
 621        # In the case of --valgrind-parallel, we only need to do the
 622        # wrapping once, in the main script.  The worker children all
 623        # have $valgrind_only_stride set, so we can skip based on that.
 624        if test -z "$valgrind_only_stride"
 625        then
 626                # override all git executables in TEST_DIRECTORY/..
 627                GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 628                mkdir -p "$GIT_VALGRIND"/bin
 629                for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 630                do
 631                        make_valgrind_symlink $file
 632                done
 633                # special-case the mergetools loadables
 634                make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 635                OLDIFS=$IFS
 636                IFS=:
 637                for path in $PATH
 638                do
 639                        ls "$path"/git-* 2> /dev/null |
 640                        while read file
 641                        do
 642                                make_valgrind_symlink "$file"
 643                        done
 644                done
 645                IFS=$OLDIFS
 646        fi
 647        PATH=$GIT_VALGRIND/bin:$PATH
 648        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 649        export GIT_VALGRIND
 650        GIT_VALGRIND_MODE="$valgrind"
 651        export GIT_VALGRIND_MODE
 652        GIT_VALGRIND_ENABLED=t
 653        if test -n "$valgrind_only" || test -n "$valgrind_only_stride"
 654        then
 655                GIT_VALGRIND_ENABLED=
 656        fi
 657        export GIT_VALGRIND_ENABLED
 658elif test -n "$GIT_TEST_INSTALLED"
 659then
 660        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 661        error "Cannot run git from $GIT_TEST_INSTALLED."
 662        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 663        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 664else # normal case, use ../bin-wrappers only unless $with_dashes:
 665        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 666        if ! test -x "$git_bin_dir/git"
 667        then
 668                if test -z "$with_dashes"
 669                then
 670                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 671                fi
 672                with_dashes=t
 673        fi
 674        PATH="$git_bin_dir:$PATH"
 675        GIT_EXEC_PATH=$GIT_BUILD_DIR
 676        if test -n "$with_dashes"
 677        then
 678                PATH="$GIT_BUILD_DIR:$PATH"
 679        fi
 680fi
 681GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 682unset GIT_CONFIG
 683GIT_CONFIG_NOSYSTEM=1
 684GIT_ATTR_NOSYSTEM=1
 685export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 686
 687if test -z "$GIT_TEST_CMP"
 688then
 689        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 690        then
 691                GIT_TEST_CMP="$DIFF -c"
 692        else
 693                GIT_TEST_CMP="$DIFF -u"
 694        fi
 695fi
 696
 697GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 698export GITPERLLIB
 699test -d "$GIT_BUILD_DIR"/templates/blt || {
 700        error "You haven't built things yet, have you?"
 701}
 702
 703if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 704then
 705        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 706        export GITPYTHONLIB
 707        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 708                error "You haven't built git_remote_helpers yet, have you?"
 709        }
 710fi
 711
 712if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 713then
 714        echo >&2 'You need to build test-chmtime:'
 715        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 716        exit 1
 717fi
 718
 719# Test repository
 720TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 721test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 722case "$TRASH_DIRECTORY" in
 723/*) ;; # absolute path is good
 724 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 725esac
 726test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 727rm -fr "$TRASH_DIRECTORY" || {
 728        GIT_EXIT_OK=t
 729        echo >&5 "FATAL: Cannot prepare test area"
 730        exit 1
 731}
 732
 733HOME="$TRASH_DIRECTORY"
 734export HOME
 735
 736if test -z "$TEST_NO_CREATE_REPO"
 737then
 738        test_create_repo "$TRASH_DIRECTORY"
 739else
 740        mkdir -p "$TRASH_DIRECTORY"
 741fi
 742
 743# Gross hack to spawn N sub-instances of the tests in parallel, and
 744# summarize the results.  Note that if this is enabled, the script
 745# terminates at the end of this 'if' block.
 746if test -n "$valgrind_parallel"
 747then
 748        for i in $(test_seq 1 $valgrind_parallel)
 749        do
 750                root="$TRASH_DIRECTORY/vgparallel-$i"
 751                mkdir "$root"
 752                TEST_OUTPUT_DIRECTORY="$root" \
 753                        ${SHELL_PATH} "$0" \
 754                        --root="$root" --statusprefix="[$i] " \
 755                        --valgrind="$valgrind" \
 756                        --valgrind-only-stride="$valgrind_parallel" \
 757                        --valgrind-only-offset="$i" &
 758                pids="$pids $!"
 759        done
 760        trap "kill $pids" INT TERM HUP
 761        wait $pids
 762        trap - INT TERM HUP
 763        for i in $(test_seq 1 $valgrind_parallel)
 764        do
 765                root="$TRASH_DIRECTORY/vgparallel-$i"
 766                eval "$(cat "$root/test-results/$(basename "$0" .sh)"-*.counts |
 767                        sed 's/^\([a-z][a-z]*\) \([0-9][0-9]*\)/inner_\1=\2/')"
 768                test_count=$(expr $test_count + $inner_total)
 769                test_success=$(expr $test_success + $inner_success)
 770                test_fixed=$(expr $test_fixed + $inner_fixed)
 771                test_broken=$(expr $test_broken + $inner_broken)
 772                test_failure=$(expr $test_failure + $inner_failed)
 773        done
 774        test_done
 775fi
 776
 777# Use -P to resolve symlinks in our working directory so that the cwd
 778# in subprocesses like git equals our $PWD (for pathname comparisons).
 779cd -P "$TRASH_DIRECTORY" || exit 1
 780
 781this_test=${0##*/}
 782this_test=${this_test%%-*}
 783if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 784then
 785        say_color info >&3 "skipping test $this_test altogether"
 786        skip_all="skip all tests in $this_test"
 787        test_done
 788fi
 789
 790# Provide an implementation of the 'yes' utility
 791yes () {
 792        if test $# = 0
 793        then
 794                y=y
 795        else
 796                y="$*"
 797        fi
 798
 799        while echo "$y"
 800        do
 801                :
 802        done
 803}
 804
 805# Fix some commands on Windows
 806case $(uname -s) in
 807*MINGW*)
 808        # Windows has its own (incompatible) sort and find
 809        sort () {
 810                /usr/bin/sort "$@"
 811        }
 812        find () {
 813                /usr/bin/find "$@"
 814        }
 815        sum () {
 816                md5sum "$@"
 817        }
 818        # git sees Windows-style pwd
 819        pwd () {
 820                builtin pwd -W
 821        }
 822        # no POSIX permissions
 823        # backslashes in pathspec are converted to '/'
 824        # exec does not inherit the PID
 825        test_set_prereq MINGW
 826        test_set_prereq NOT_CYGWIN
 827        test_set_prereq SED_STRIPS_CR
 828        test_set_prereq GREP_STRIPS_CR
 829        ;;
 830*CYGWIN*)
 831        test_set_prereq POSIXPERM
 832        test_set_prereq EXECKEEPSPID
 833        test_set_prereq NOT_MINGW
 834        test_set_prereq CYGWIN
 835        test_set_prereq SED_STRIPS_CR
 836        test_set_prereq GREP_STRIPS_CR
 837        ;;
 838*)
 839        test_set_prereq POSIXPERM
 840        test_set_prereq BSLASHPSPEC
 841        test_set_prereq EXECKEEPSPID
 842        test_set_prereq NOT_MINGW
 843        test_set_prereq NOT_CYGWIN
 844        ;;
 845esac
 846
 847( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 848test -z "$NO_PERL" && test_set_prereq PERL
 849test -z "$NO_PYTHON" && test_set_prereq PYTHON
 850test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 851test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 852
 853# Can we rely on git's output in the C locale?
 854if test -n "$GETTEXT_POISON"
 855then
 856        GIT_GETTEXT_POISON=YesPlease
 857        export GIT_GETTEXT_POISON
 858        test_set_prereq GETTEXT_POISON
 859else
 860        test_set_prereq C_LOCALE_OUTPUT
 861fi
 862
 863# Use this instead of test_cmp to compare files that contain expected and
 864# actual output from git commands that can be translated.  When running
 865# under GETTEXT_POISON this pretends that the command produced expected
 866# results.
 867test_i18ncmp () {
 868        test -n "$GETTEXT_POISON" || test_cmp "$@"
 869}
 870
 871# Use this instead of "grep expected-string actual" to see if the
 872# output from a git command that can be translated either contains an
 873# expected string, or does not contain an unwanted one.  When running
 874# under GETTEXT_POISON this pretends that the command produced expected
 875# results.
 876test_i18ngrep () {
 877        if test -n "$GETTEXT_POISON"
 878        then
 879            : # pretend success
 880        elif test "x!" = "x$1"
 881        then
 882                shift
 883                ! grep "$@"
 884        else
 885                grep "$@"
 886        fi
 887}
 888
 889test_lazy_prereq PIPE '
 890        # test whether the filesystem supports FIFOs
 891        case $(uname -s) in
 892        CYGWIN*)
 893                false
 894                ;;
 895        *)
 896                rm -f testfifo && mkfifo testfifo
 897                ;;
 898        esac
 899'
 900
 901test_lazy_prereq SYMLINKS '
 902        # test whether the filesystem supports symbolic links
 903        ln -s x y && test -h y
 904'
 905
 906test_lazy_prereq CASE_INSENSITIVE_FS '
 907        echo good >CamelCase &&
 908        echo bad >camelcase &&
 909        test "$(cat CamelCase)" != good
 910'
 911
 912test_lazy_prereq UTF8_NFD_TO_NFC '
 913        # check whether FS converts nfd unicode to nfc
 914        auml=$(printf "\303\244")
 915        aumlcdiar=$(printf "\141\314\210")
 916        >"$auml" &&
 917        case "$(echo *)" in
 918        "$aumlcdiar")
 919                true ;;
 920        *)
 921                false ;;
 922        esac
 923'
 924
 925test_lazy_prereq AUTOIDENT '
 926        sane_unset GIT_AUTHOR_NAME &&
 927        sane_unset GIT_AUTHOR_EMAIL &&
 928        git var GIT_AUTHOR_IDENT
 929'
 930
 931# When the tests are run as root, permission tests will report that
 932# things are writable when they shouldn't be.
 933test -w / || test_set_prereq SANITY
 934
 935GIT_UNZIP=${GIT_UNZIP:-unzip}
 936test_lazy_prereq UNZIP '
 937        "$GIT_UNZIP" -v
 938        test $? -ne 127
 939'